unit MainFM;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  OleCtrls, StdCtrls, FileCtrl, ExtCtrls, ComCtrls, FilesScn, Grids;

type
  TForm1 = class(TForm)
    Button1: TButton;
    StatusInd: TLabel;
    Button2: TButton;
    Edit1: TEdit;
    UpdateListCheck: TCheckBox;
    RecursivCheck: TCheckBox;
    MessagCheck: TCheckBox;
    ScanDirEdit: TEdit;
    Bevel1: TBevel;
    cArchive: TCheckBox;
    cDirectory: TCheckBox;
    cHidden: TCheckBox;
    cReadonly: TCheckBox;
    cSysFile: TCheckBox;
    cVolumeID: TCheckBox;
    Bevel2: TBevel;
    Bevel3: TBevel;
    cGlobal: TRadioButton;
    cSpecifedDisk: TRadioButton;
    cSpecifedDir: TRadioButton;
    StringGrid1: TStringGrid;
    Panel1: TPanel;
    cByName: TRadioButton;
    cUnsort: TRadioButton;
    cBySize: TRadioButton;
    cByTime: TRadioButton;
    FilesScan1: TFilesScanner;
    procedure Button1Click(Sender: TObject);
    procedure FilesScan1Changed(Sender: TObject;
      FilesCount, FilesSize: Integer);
    procedure FilesScan1Process(Sender: TObject; Dir: String; FilesCount,
      FilesSize: Integer);
    procedure Button2Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure UpdateListCheckClick(Sender: TObject);
    procedure RecursivCheckClick(Sender: TObject);
    procedure MessagCheckClick(Sender: TObject);
    procedure ScanDirEditChange(Sender: TObject);
    procedure cArchiveClick(Sender: TObject);
    procedure cDirectoryClick(Sender: TObject);
    procedure cHiddenClick(Sender: TObject);
    procedure cReadonlyClick(Sender: TObject);
    procedure cSysFileClick(Sender: TObject);
    procedure cVolumeIDClick(Sender: TObject);
    procedure cGlobalClick(Sender: TObject);
    procedure cSpecifedDiskClick(Sender: TObject);
    procedure cSpecifedDirClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure cUnsortClick(Sender: TObject);
    procedure cByNameClick(Sender: TObject);
    procedure cBySizeClick(Sender: TObject);
    procedure cByTimeClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
uses Masks, Fllist;

{$R *.DFM}
procedure PutIntoGrid(AGrid : TStringGrid; Col, Row: longint;
                       S : string);
var L : integer;
begin
  L := AGrid.Canvas.TextWidth(S)+10;
  if L > AGrid.ColWidths[Col] then AGrid.ColWidths[Col] := L;
  AGrid.Cells[Col, Row] := S;
end;

procedure EmptyRow(AGrid : TStringGrid; ARow, AColCount: longint);
var i : longint;
begin
  for i := 0 to AColCount do AGrid.Cells[i, ARow] := '';
end;
procedure TForm1.Button1Click(Sender: TObject);
begin
  FilesScan1.Scan;
end;

procedure TForm1.FilesScan1Changed(Sender: TObject;
        FilesCount, FilesSize: Integer);
var i : cardinal;
    F : TFileObject;
begin
  StatusInd.Caption := 'Total files '+IntToStr(FilesCount)+' size '+
                     IntToStr(FilesSize div 1024)+ ' Kb';
  with StringGrid1 do
  begin
    RowCount := 2;
    FixedRows := 1;
    EmptyRow(StringGrid1, 1, 4);
    if FilesScan1.Files.Count = 0 then exit else
       StringGrid1.RowCount := FilesScan1.Files.Count+1;
    for i := 0 to Pred(FilesScan1.Files.Count) do
    begin
      F := TFileObject(FilesScan1.Files.Items[i]);
      PutIntoGrid(StringGrid1, 0, i+1,F.FileName);
      PutIntoGrid(StringGrid1, 1, i+1,IntToStr(F.FileSize));
      PutIntoGrid(StringGrid1, 2, i+1,DateToStr(FileDateToDateTime(F.FileTime)));
      PutIntoGrid(StringGrid1, 3, i+1,GetFileAttrStr(F.FileAttr));
      PutIntoGrid(StringGrid1, 4, i+1,F.FullPath);
    end;
    Update;
  end;
end;

procedure TForm1.FilesScan1Process(Sender: TObject; Dir: String;
  FilesCount, FilesSize: Integer);
begin
  StatusInd.Caption := Dir;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  FilesScan1.Stop;
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
  FilesScan1.FileMask := Edit1.Text;
end;

procedure TForm1.UpdateListCheckClick(Sender: TObject);
begin
  FilesScan1.UpdateList := UpdateListCheck.Checked;
end;

procedure TForm1.RecursivCheckClick(Sender: TObject);
begin
  FilesScan1.Recursive := RecursivCheck.Checked;
end;

procedure TForm1.MessagCheckClick(Sender: TObject);
begin
  FilesScan1.ProcessMsg := MessagCheck.Checked;
end;

procedure TForm1.ScanDirEditChange(Sender: TObject);
begin
  FilesScan1.ScanDir := ScanDirEdit.Text;
end;

procedure TForm1.cArchiveClick(Sender: TObject);
begin
  if cArchive.Checked then
     FilesScan1.Attributes := FilesScan1.Attributes + [faArchive]
     else
     FilesScan1.Attributes := FilesScan1.Attributes - [faArchive]
end;

procedure TForm1.cDirectoryClick(Sender: TObject);
begin
  if cDirectory.Checked then
     FilesScan1.Attributes := FilesScan1.Attributes + [faDirectory]
     else
     FilesScan1.Attributes := FilesScan1.Attributes - [faDirectory]
end;

procedure TForm1.cHiddenClick(Sender: TObject);
begin
  if cHidden.Checked then
     FilesScan1.Attributes := FilesScan1.Attributes + [faHidden]
     else
     FilesScan1.Attributes := FilesScan1.Attributes - [faHidden]
end;

procedure TForm1.cReadonlyClick(Sender: TObject);
begin
  if cReadonly.Checked then
     FilesScan1.Attributes := FilesScan1.Attributes + [faReadonly]
     else
     FilesScan1.Attributes := FilesScan1.Attributes - [faReadonly]
end;

procedure TForm1.cSysFileClick(Sender: TObject);
begin
  if cSysFile.Checked then
     FilesScan1.Attributes := FilesScan1.Attributes + [faSysFile]
     else
     FilesScan1.Attributes := FilesScan1.Attributes - [faSysFile]
end;

procedure TForm1.cVolumeIDClick(Sender: TObject);
begin
  if cVolumeID.Checked then
     FilesScan1.Attributes := FilesScan1.Attributes + [faVolumeID]
     else
     FilesScan1.Attributes := FilesScan1.Attributes - [faVolumeID]
end;

procedure TForm1.cGlobalClick(Sender: TObject);
begin
  FilesScan1.ScanOptions := soGlobal;
end;

procedure TForm1.cSpecifedDiskClick(Sender: TObject);
begin
  FilesScan1.ScanOptions := soSpecifiedDisk;
end;

procedure TForm1.cSpecifedDirClick(Sender: TObject);
begin
  FilesScan1.ScanOptions := soSpecifiedDir;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  with StringGrid1 do
  begin
    Cells[0, 0] := 'File name';
    Cells[1, 0] := 'Size';
    Cells[2, 0] := 'Date';
    Cells[3, 0] := 'Attr';
    Cells[4, 0] := 'Full path';
  end;
end;

procedure TForm1.cUnsortClick(Sender: TObject);
begin
  FilesScan1.Sorted := soUnsort;
end;

procedure TForm1.cByNameClick(Sender: TObject);
begin
  FilesScan1.Sorted := soByName;
end;

procedure TForm1.cBySizeClick(Sender: TObject);
begin
  FilesScan1.Sorted := soBySize;
end;

procedure TForm1.cByTimeClick(Sender: TObject);
begin
  FilesScan1.Sorted := soByTime;
end;

end.
